<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 22/09/2014
 * Time: 10:16
 */

namespace Geral\Logic\FonteDados;

use Geral\Entities\Paramsqlfontedados;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class ParametroSQL {
    public static function getParamsSQL($sql)
    {
        $sql = nl2br($sql);
        $sql = str_replace(array('<br />'), array(' '), $sql);
        $valida = strpbrk($sql, ':');

        //Testa se existem parâmetros.
        if($valida) {
            $params       = array();
            $paramReplace = array();

            do{
                //Encontra o primeiro ":" e pega a string a partir daí.
                $sql = strpbrk($sql, ':');

                //Quebra a nova string em pedaços baseando em espaços, para pegar sua primeira posição.
                $sqlArray = explode(' ', $sql);

                if($sqlArray[0] != '') {
                    //Possíveis caracteres que não façam parte do parâmetro.
                    if(strstr($sqlArray[0], '(') || strstr($sqlArray[0], ')') || strstr($sqlArray[0], ',')) {
                        $sqlArray[0] = str_replace(array('(', ')', ','), array(' ', ' ', ' '), $sqlArray[0]);
                        $sqlArray = explode(' ', $sqlArray[0]);
                    }
                    //Retira os caracteres não necessários do parâmetro, que é a primeira posição do array criado.
                    $param    = ltrim($sqlArray[0], ':');
                    $param    = rtrim($param);
                    $params[] = $param;
                    $paramReplace[] = rtrim($sqlArray[0]);
                }

                //Pega o resto da string, do espaço dpois do parâmetro em questão em diante para pegar os próximos.
                $sql = strpbrk($sql, ' ');
            } while($sql);

            //Retira posições repetidas.
            $params = array_unique($params);
            $paramReplace = array_unique($paramReplace);

            $params[] = $paramReplace;
        } else {
            $params = false;
        }

        return $params;
    }

    public static function insertParametro($dsParam, $nrOrg, $linha, $dataAtual, $cdOperador)
    {
        $coluna = new Paramsqlfontedados();

        $coluna->setNrparamsqlfontedados(NovoCodigo::geraCodigo($nrOrg, 'PARAMSQLFONTEDADOS', 1, 10, true, false));
        $coluna->setDsparamsqlfontedados($dsParam);
        $coluna->setNrlinhafontedados($linha);
        $coluna->setIdativo('S');
        $coluna->setNrorg($nrOrg);
        $coluna->setNrorginclusao($nrOrg);
        $coluna->setNrorgultatu($nrOrg);
        $coluna->setDtinclusao($dataAtual);
        $coluna->setDtultatu($dataAtual);
        $coluna->setCdoperinclusao($cdOperador);
        $coluna->setCdoperultatu($cdOperador);

        $coluna->persist();
    }

    public static function deleteParametros($nrLinha, $nrOrg)
    {
        $parametros = Paramsqlfontedados::findByNrlinhafontedadosAndNrorg($nrLinha, $nrOrg);

        foreach($parametros as $parametro) {
            $parametro->delete();
        }

        Registry::getEntityManager()->flush();
    }
} 