/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LUSO                                                     */
/* Tabela : LICENCAUSO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LUSO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_LUSO
GO

CREATE TRIGGER DTULTATU_LUSO
ON LICENCAUSO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'LICENCAUSO', null, 'CDCLIENTE='+ CDCLIENTE+ ';'+
                                         'NRLICENCAUSO='+ NRLICENCAUSO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LICENCAUSO
      SET DTULTATULUSO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(LICENCAUSO.NMFANTLUSO,0)   = ISNULL(INSERTED.NMFANTLUSO,0))   AND
            (ISNULL(LICENCAUSO.NRINSESTLUSO,0) = ISNULL(INSERTED.NRINSESTLUSO,0)) AND
            (ISNULL(LICENCAUSO.DSENDELUSO,0)   = ISNULL(INSERTED.DSENDELUSO,0))   AND
            (ISNULL(LICENCAUSO.NMBAIRLUSO,0)   = ISNULL(INSERTED.NMBAIRLUSO,0))   AND
            (ISNULL(LICENCAUSO.NRCEPLUSO,0)    = ISNULL(INSERTED.NRCEPLUSO,0))    AND
            (ISNULL(LICENCAUSO.NRTELELUSO,0)   = ISNULL(INSERTED.NRTELELUSO,0))   AND
            (ISNULL(LICENCAUSO.SGESTADO,0)     = ISNULL(INSERTED.SGESTADO,0))     AND
            (ISNULL(LICENCAUSO.CDPAIS,0)       = ISNULL(INSERTED.CDPAIS,0))       AND
            (ISNULL(LICENCAUSO.CDLOCALUSO,0)   = ISNULL(INSERTED.CDLOCALUSO,0))   AND
            (ISNULL(LICENCAUSO.NRLICENCAUSO,0) = ISNULL(INSERTED.NRLICENCAUSO,0)) AND
            (ISNULL(LICENCAUSO.IDTPIJURLUSO,0) = ISNULL(INSERTED.IDTPIJURLUSO,0)) AND
            (ISNULL(LICENCAUSO.NRINSJURLUSO,0) = ISNULL(INSERTED.NRINSJURLUSO,0)) AND
            (ISNULL(LICENCAUSO.CDMUNICIPIO,0)  = ISNULL(INSERTED.CDMUNICIPIO,0))  AND
            (ISNULL(LICENCAUSO.CDCLIENTE,0)    = ISNULL(INSERTED.CDCLIENTE,0))    AND
            (ISNULL(LICENCAUSO.CDLOCALUSO,0)   = ISNULL(INSERTED.CDLOCALUSO,0));
   END;
END;
GO

