<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class GpeFasetramsoli extends \Doctrine\ORM\EntityRepository {
    
    public function retornaFaseatual($nrorg, $nrsolicitacao) {
        $gpeFasetramsoli = Repositories::GPE_FASETRAMSOLI;
        $gpeFaseaprovsoli = Repositories::GPE_FASEAPROVSOLI;

        $sql = <<<SQL
SELECT f
  FROM $gpeFasetramsoli a
  JOIN $gpeFaseaprovsoli f WITH f.nrorg = a.nrorg
                            AND f.nrfaseaprovsoli = a.nrfaseaprovsoli
 WHERE a.nrorg = :nrorg
   AND a.nrsolicitacao = :nrsolicitacao
 ORDER BY f.nrordem ASC
SQL;
        $params = array(
            'nrorg' => $nrorg,
            'nrsolicitacao' => $nrsolicitacao
        );
        $results = $this->getEntityManager()->createQuery($sql)->execute($params);
        $result = end($results);
        return $result;
    }
    
}